#ifndef LBXIMG_H_
#define LBXIMG_H_

#include <stdio.h>

struct lbx_file_ops;

typedef struct lbx_image {
	unsigned short width, height;
	unsigned char frames, chunk;
} LBXimg;

struct lbx_colour {
	unsigned char red;
	unsigned char green;
	unsigned char blue;
	unsigned char active;
};

struct lbx_imginfo {
	unsigned short width, height;
	unsigned char  nframes, loopstart, chunk;
	int palettesz, looping;
};

LBXimg *lbx_img_open(void *f, const struct lbx_file_ops *fops,
                     int (*destructor)(void *));
LBXimg *lbx_img_fopen(const char *file);
int     lbx_img_close(LBXimg *img);

unsigned char **lbx_img_getframe(LBXimg *img, int frame);
unsigned char **lbx_img_getmask(LBXimg *img);

int lbx_img_loadpalette(void *f, const struct lbx_file_ops *fops,
                       struct lbx_colour palette[static 256]);
int lbx_img_getpalette(LBXimg *img, struct lbx_colour palette[static 256]);

void lbx_img_getinfo(LBXimg *img, struct lbx_imginfo *info);

#endif
